import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

public class ToxicWorld extends World
{
  private Vidas vida;
  private GeneraHab habitante;
  public int dirHab;
  private menosContaminado menosCont;
  private muyContaminado masCont;
  private int numLlavesCerradas;
  private int numAhogados;
  private boolean existeHabitante;
  

  
    public ToxicWorld()
    {           
        super(120,120,5); 
        addObject(new Limpio(),59,60);
        this.agregaAguaContaminada();
        this.agregaTroncos();
        this.agregaFabricas();
        this.agregaTuberias();
        this.agregaLlavesAba();//agrega las llaves que stan n la parte d arriba de las tuberias
        this.agregaAlex();
        this.agregaLlavesArr();//agrega las  llaves que stan n la parte de abajo de las tuberias
        vida =new Vidas();
        addObject(vida,58,115);
        habitante=new GeneraHab();
        addObject(habitante,0,0);//genera los habitantes que se acercan al rio
        numLlavesCerradas=0;     
        numAhogados=0;
    }
    
    public void agregaAguaContaminada()
    {
       menosCont=new menosContaminado();
       addObject(menosCont,59,60);    
       masCont=new muyContaminado();
      addObject(masCont,59,60); 

    }    
    
    public void agregaFabricas()
    {
      addObject(new Fabrica(),11,10);   
      addObject(new Fabrica(),108,10);
    }   
    
    public void agregaTroncos()
    {
     int y1=2;   
     int y2=5;
     
     for(int i=1;i<16;i++)
     {   
       addObject(new Tronco(),50,y1);
       addObject(new Tronco(),69,y1);
       y1=y1+8;
      
     }

   }    
   
  public void agregaTuberias()
  {
      addObject(new tub1(),30,17);
      addObject(new tub2_1(),15,27);  
      addObject(new tub2_2(),26,36);
      addObject(new tub3_1(),7,43);  
      addObject(new tub3_2(),22,67);
      addObject(new tub4(),88,16);
      addObject(new tub5_1(),104,37);  
      addObject(new tub5_2(),91,53);
      addObject(new tub6_1(),112,50);  
      addObject(new tub6_2(),95,79);
    
    }    
   
 public void agregaLlavesArr()
  {
    addObject(new Llave(),23,11);    
    addObject(new Llave(),95,11);
    addObject(new Llave(),100,47);
    addObject(new Llave(),108,73);
  
  }   
  
  public void agregaLlavesAba()
  {
    addObject(new Llave(),15,38);
    addObject(new Llave(),5,67);       
  }   
  
  public void agregaAlex()
  {
    addObject(new Alex(),70,12);    
  }   
  
  public void terminaJuego()
  {
      
   if(numLlavesCerradas==6)
    {
        remueveObjetos();
        setBackground("gano.png");
        stopped();
    }    
  
    else
    {
        remueveObjetos();
        setBackground("perdio.png");
        stopped();
    } 
  }   
  

 
 public void decrementaVidas()
 {
    
    vida.disminuyeVida();

 }  
  
  public void remueveObjetos()
  {
   
   if(numLlavesCerradas>0)//hay al mnos una llave cerrada
     removeObjects(getObjects(LlaveCerrada.class));
   if(numLlavesCerradas<6)//Todavia hay llaves abiertas
     removeObjects(getObjects(Llave.class)); 
     
   if(existeHabitante)
        removeObjects(getObjects(Habitantes.class));
     
   removeObjects(getObjects(Alex.class));
   removeObjects(getObjects(Tronco.class));
   removeObjects(getObjects(Tuberias.class));
   removeObjects(getObjects(Fabrica.class));
   removeObjects(getObjects(GeneraHab.class));
   removeObjects(getObjects(Vidas.class));
   removeObjects(getObjects(Rio.class));
   
      
  } 
  
 
  public void limpiaRio(int llavesCerradas)
  {
    numLlavesCerradas=llavesCerradas;
    
   if(numLlavesCerradas==4)
      removeObject(masCont);
   else
    if(numLlavesCerradas==6)
     {
      removeObject(menosCont);
      this.terminaJuego();
     }
     
  }    
  
  public void incrNumAhogados()
  {
    numAhogados++;    
  }    
 
  public void generoHabitante(boolean genero)
  {
   existeHabitante=genero;
  }   
}
