import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

public class Alex  extends Actor
{
 private int vueltasLlave;
 private int dir;
 private int vidas;
 private int velCaida;
 private int salto;
 private int dirX;
 private int haciaDerecha;
 private int haciaIzquierda;
 private int haciaArriba;
 private int haciaAbajo;
 private int numAct;
 private int numLlavesCerradas;

 
public Alex()
  {
      vueltasLlave=0;
      dir=-2;
      velCaida=0;
      salto=0;
      dirX=0;
      haciaDerecha=0;
      haciaIzquierda=0;
      haciaArriba=0;
      haciaAbajo=0;
      vidas=3;
      numLlavesCerradas=0;
  }
 

   public void act() 
    {
       checaTeclas();
       mantenerEnElTronco();
       if(reubicaAlex())
         decrementaVida();
       
   }   

    public void dispara()
    {
        World w=getWorld();  
        
      if(dir==1)//A la derecha
        w.addObject(new disparoDer(),getX()+1,getY());
      else
       if(dir==-1)//a la izq
          w.addObject(new disparoIzq(),getX()-1,getY());

    }   
         

     public void mantenerEnElTronco()
     {
       if(estaEnTronco())
          {
           Actor tronco;
           tronco= getOneObjectAtOffset(0,5,Tronco.class);    
           setLocation(this.getX(),tronco.getY()-5);
          }   
       
     }      
    
    public boolean estaEnTronco()
    {
      Actor enTronco=  getOneObjectAtOffset(0,5,Tronco.class);    
      if(enTronco!=null)
       return true;
      else
       return false;
        
    }    
    
  public void checaTeclas()
  {
      int x=this.getX();
      int y=this.getY();
      
      if(Greenfoot.isKeyDown("right"))
        {
          if(intersectaObjetosDer()==false)
          {
           dir=1;  
           reiniciaVariablesDir(dir);
         
            if(haciaDerecha>0)
                setLocation(x+5,y);
           cambiaImagen();    
           haciaDerecha++;
           if(haciaDerecha==4)
            haciaDerecha=0;
          }  
        } 
      else
       if(Greenfoot.isKeyDown("left"))
         {
           if(intersectaObjetosIzq()==false)
          {
            dir=-1;  
            reiniciaVariablesDir(dir);
           
            if(haciaIzquierda>0)
                setLocation(x-5,y);
             cambiaImagen();    
            haciaIzquierda++;
            if(haciaIzquierda==4)
              haciaIzquierda=0;
          }    
         }  
       else
        if(Greenfoot.isKeyDown("up"))
          {
           if(intersectaObjetosArriba()==false)   
            {
              dir=2;   
               reiniciaVariablesDir(dir);
              if(haciaArriba>0)
              setLocation(getX(),getY()-5);
             cambiaImagen();   
             haciaArriba++;
             if(haciaArriba==4)
               haciaArriba=0;
            }    
         }   
        else
         if(Greenfoot.isKeyDown("down"))
           {
             if(intersectaObjetosAbajo()==false)    
             {
              dir=-2; 
               reiniciaVariablesDir(dir);
              if(haciaAbajo>0)
                setLocation(getX(),getY()+5);
               cambiaImagen();  
              haciaAbajo++;
              if(haciaAbajo==5)
               haciaAbajo=0;
            }   
           } 
        else 
         if(Greenfoot.isKeyDown("s"))
          {
           if(dir==2 || dir==-2)//Si esta volteado hacia arriba o hacia abajo
           {
            dirX=1;//Indica que X crece 
            salto++;
            cambiaImagen();   
            cambiaVelCaida();
            caida();
          } 
            if(salto==5)
               salto=0;
               
        
          }
         else
           if(Greenfoot.isKeyDown("a"))
          {
            if(dir==2 || dir==-2)
           {
            dirX=2;//Indica que X disminuye 
            salto++;
            cambiaImagen();   
            cambiaVelCaida();
            caida();
           }
            if(salto==5)
               salto=0;
               
          }
          else
           if(Greenfoot.isKeyDown("c"))
              cerrarLlave();
           else
             if(Greenfoot.isKeyDown("space"))
                   dispara();
          
   }   
   
     
   
   public void cambiaVelCaida()
   {
      if(dir==-2)
        {
          if(salto<3)
            velCaida=-9;
          else
            velCaida=9;
        }
      else
        if(dir==2)
           {
             if(salto<4)
               velCaida=-9;
             else
               velCaida=9;
               
           }   
        
         
   }
    
   
   
  public void cerrarLlave()
   {
     Actor cercaLlave=getOneObjectAtOffset(0,0,Llave.class);
     if(cercaLlave!=null)
        {
         Llave cerrando=(Llave)cercaLlave;
         cerrando.incrementaVueltas();
        }   
        
  }   
       
   public boolean reubicaAlex()
    {
     World w=getWorld();   
     if(this.getY()==w.getHeight()-1 //si llego al final de la pantalla en Y
      || ( (!estaEnTronco()&&(intersectaRio() && salto==0) ) ) )//si intersecto cn el rio pero cayo, no estaba brincando
        {
         setLocation(32,8);
        
          return true;
        }
      return false; 
    }  
    

   
  public boolean intersectaRio()
   {
     boolean intersecto=false;
     
     if(getOneObjectAtOffset(0,5,Rio.class)!=null)
         intersecto=true;
        
     return intersecto; 
   }    
   
   
  public boolean intersectaObjetosIzq()
  {
     boolean intersecto=false;
      if(this.getOneObjectAtOffset(-2,0,Tuberias.class)!=null
         ||
        this.getOneObjectAtOffset(-2,0,Fabrica.class)!=null )
        intersecto=true;
        
     return intersecto; 
  }    
   
  public boolean intersectaObjetosDer()
  {
    boolean intersecto=false;
      if(this.getOneObjectAtOffset(2,0,Tuberias.class)!=null
         ||
        this.getOneObjectAtOffset(2,0,Fabrica.class)!=null )
        intersecto=true;
        
     return intersecto; 
  } 
  
  public boolean intersectaObjetosArriba()
  {
    boolean intersecto=false;
      if(this.getOneObjectAtOffset(0,-5,Tuberias.class)!=null
         ||
        this.getOneObjectAtOffset(0,-5,Fabrica.class)!=null )
        intersecto=true;
        
     return intersecto; 
  } 
  
  public boolean intersectaObjetosAbajo()
  {
    boolean intersecto=false;
      if(this.getOneObjectAtOffset(0,7,Tuberias.class)!=null
         ||
        this.getOneObjectAtOffset(0,7,Fabrica.class)!=null )
        intersecto=true;
        
     return intersecto; 
  } 
  
  
  
  public void caida()
  {
    if(dirX==1)  
      setLocation(getX()+salto,getY()+ velCaida);
    else
      setLocation(getX()-salto,getY()+ velCaida);
       
  }  

  
  
 public void cambiaImagen()
  {
   switch(dir)  
     {   
        case 1://Si va hacia la derecha
             {
                switch(haciaDerecha)
                  {
                    case 0:setImage("camDer1.png");break;  
                    case 1:setImage("camDer2.png");break;
                    case 2:setImage("camDer3.png");break;
                    
                
                  }    
                 
             }    
          break;   
          
          case -1://Si va hacia la izq
             {
                switch(haciaIzquierda)
                  {
                    case 0:setImage("camIzq1.png");break;  
                    case 1:setImage("camIzq2.png");break;
                    case 2:setImage("camIzq3.png");break;       
                 
                  }    
                 
             }    
          break;  
         
         
        case 2://Si va hacia arriba
               {
                  if(haciaArriba==0||salto==0)
                       setImage("espaldas.png");
                  
                  if(haciaArriba!=0)
                  {
                    switch(haciaArriba)
                      {
                         case 1:setImage("arr1.png");break;
                         case 2:setImage("arr2.png");break;
                         case 3:setImage("arr3.png");break;
                         case 4:setImage("arr4.png");break; 
                      }   
                  }   
                  
                    
                    if(dirX==1)//brinco hacia arriba a la derecha
                      {
                         switch(salto)
                          {
                             case 1:setImage("suder1.png");break;
                             case 2:setImage("suder2.png");break;
                             case 3:setImage("suder3.png");break;
                             case 4:setImage("suder4.png");break; 
                           } 
                      }  
                    else//brinco hacia arriba a la izq
                       {
                          switch(salto)
                            {
                                    
                              case 1:setImage("suizq1.png");break;
                              case 2:setImage("suizq2.png");break;
                              case 3:setImage("suizq3.png");break;
                              case 4:setImage("suizq4.png");break; 
                            } 
                        }    
                     } break;//fin del si va hacia arriba 
            
        case -2://Si va hacia abajo    
                {
                  if(haciaAbajo==0||salto==0)
                       setImage("frente.png");
                  
                  if(haciaAbajo!=0)
                  {
                    switch(haciaAbajo)
                      {
                         case 1:setImage("abajo1.png");break;
                         case 2:setImage("abajo2.png");break;
                         case 3:setImage("abajo3.png");break;
                      }   
                  }   
                  
                    
                    if(dirX==1)//brinco hacia abajo a la derecha
                      {
                         switch(salto)
                          {
                             case 1:setImage("sder1.png");break;
                             case 2:setImage("sder2.png");break;
                             case 3:setImage("sder3.png");break;
                             case 4:setImage("sder4.png");break; 
                           } 
                      }  
                    else//brinco hacia abajo a la izq
                       {
                          switch(salto)
                            {
                                    
                              case 1:setImage("sizq1.png");break;
                              case 2:setImage("sizq2.png");break;
                              case 3:setImage("sizq3.png");break;
                              case 4:setImage("sizq4.png");break; 
                            } 
                        }    
                     }break;//fin del si va hacia abajo
          
       }//fin del switch  
   }      
   
   
   public void decrementaVida()
   {
     vidas--;
     ((ToxicWorld)getWorld()).decrementaVidas();
     if(vidas==0)
      ((ToxicWorld)getWorld()).terminaJuego();
       
   }    
   
   public void incrementaLlavesCerradas()
   {
     numLlavesCerradas++;  
    ((ToxicWorld)getWorld()).limpiaRio(numLlavesCerradas);  
        
   }   
      
   
   public void reiniciaVariablesDir(int dir)
   {
     switch (dir)
     {
      case 1:
             haciaIzquierda=0;
             haciaAbajo=0;
             haciaArriba=0;
             salto=0;
             break;
             
      case -1:
              haciaDerecha=0;
              haciaAbajo=0;
              haciaArriba=0;
              salto=0;
              break;
              
     case 2:
              haciaDerecha=0;
              haciaIzquierda=0;
              haciaAbajo=0;
              salto=0;
              break;
              
     case -2:
              haciaDerecha=0;
              haciaIzquierda=0;
              haciaArriba=0;
              salto=0;
              break;
                            
    }   
    
   }
  
}
